
#ifndef __PBBXOSD_HH__
#define __PBBXOSD_HH__

#include "PBB.hh"

class PBBXosd : public PBBView
{
 public:	
  PBBXosd ();
  virtual ~PBBXosd ();
  
  virtual void Register (PBBRegistry* reg);
  
  virtual bool Init (const std::string& priv);
  virtual void Main (PBBInterface* interface, bool nodemo);
  
  virtual void BrightnessChange (int i);
  virtual void AudioVolumeChange (int i);
  virtual void NoAudio ();
  virtual void AudioMuted ();
  virtual void TrackpadModeChange (int i);
  virtual void BatteryLevelChange (int i);
  virtual void MinutesRemaining (int i);
  virtual void SecondsToSleep (int i);

 private:
  void PrintError ();
  
  bool ShowText (int row, std::string text);
  bool ShowPercentage (int row, int value);
  bool IsDisplayed ();
  void WaitNotDisplayed ();
 
  xosd* osd; 
};

#endif // __PBBXOSD_HH__
