/*
 * --- GSMP-COPYRIGHT-NOTE-BEGIN ---
 * 
 * This copyright note is auto-generated by ./scripts/Create-CopyPatch.
 * Please add additional copyright information _after_ the line containing
 * the GSMP-COPYRIGHT-NOTE-END tag. Otherwise it might get removed by
 * the ./scripts/Create-CopyPatch script. Do not edit this copyright text!
 * 
 * GSMP: utility/include/File.hh
 * General Sound Manipulation Program is Copyright (C) 2000 - 2004
 *   Valentin Ziegler and Ren Rebe
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2. A copy of the GNU General
 * Public License can be found in the file LICENSE.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
 * ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * --- GSMP-COPYRIGHT-NOTE-END ---
 */

/* Short Description:
 *   A simple POSIX file abstraction.
 */

#ifndef UTILITY__FILE_HH__
#define UTILITY__FILE_HH__

#include <sys/stat.h>

#include <string>

namespace Utility
{
   
  /* this is some wrapping around the (ugly) posix directory stuff
     not really a perfectly crafted object */
  class File
  {
  public:
    File (const std::string& str);
    ~File ();
  
    const std::string& Basename ();
    const std::string& Extension ();
    
    bool IsDirectory ();
    bool IsSymlink ();
    bool IsFile ();
    
    const std::string Name () const {
      return filename;
    }
    
    // more to be done on demand
    
 private:
  
    inline bool updateStat ();
    void updateBaseExt ();
    
    std::string filename;
    std::string basename; // just cached
    std::string extension; // just cached
    
    struct stat c_stat;
    bool c_stat_valid;
  };
  
  std::ostream& operator<< (std::ostream& os, const File& file) {
    os << file.Name ();
    return os;
  }

} // namespace Utility

#endif // UTILITY__FILE_HH__
